package com.ruoyi.system.domain.loan;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;
import java.util.Map;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.ruoyi.system.domain.enterprise.SysUserEnterprise;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import com.ruoyi.common.annotation.Excel;
import com.ruoyi.common.core.domain.BaseEntity;

/**
 * 贷款申请主对象 loan_application
 * 
 * @author boman
 * @date 2024-04-24
 */
public class LoanApplication extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** 贷款申请id */
    private Long loanApplicationId;

    /** 贷款申请编号 */
    private String loanApplicationNumber;
    /**
     * 申请类型 1：企业 2：个人
     */
    private String applicationType;

    /** 申请额度(万元) */
    @Excel(name = "申请额度(万元)")
    private Double applicationAmount;

    /** 申请银行 */
    @Excel(name = "申请银行")
    private String applicationBank;

    /** 使用期限(月) */
    @Excel(name = "使用期限(月)")
    private String usagePeriod;

    /** 资金用途 */
    @Excel(name = "资金用途")
    private String purposeFunds;

    /** 还款来源 */
    @Excel(name = "还款来源")
    private String repaymentSource;

    /** 企业名称 */
    @Excel(name = "企业名称")
    private String enterpriseName;
    /** 企业对应的id */
    private Long enterpriseId;
    /**
     * 企业对象
     */
    private SysUserEnterprise sysUserEnterprise;

    /** 行业类型 */
    @Excel(name = "行业类型")
    private String categoryType;

    /** 是否是制造业 Y：是 N：否 */
    @Excel(name = "是否是制造业 Y：是 N：否")
    private String isMake;

    /** 是否是精特新 Y：是 N：否 */
    @Excel(name = "是否是精特新 Y：是 N：否")
    private String isNew;

    /** 是否是小微企业 Y：是 N：否 */
    @Excel(name = "是否是小微企业 Y：是 N：否")
    private String isSmall;

    /** 是否是免税企业 Y：是 N：否 */
    @Excel(name = "是否是免税企业 Y：是 N：否")
    private String isDuty;

    /** 公司简介 */
    @Excel(name = "公司简介")
    private String companyIntroduction;

    /** 用户类型 */
    @Excel(name = "用户类型")
    private String customerType;

    /** 法人身份证正面 */
    @Excel(name = "法人身份证正面")
    private String corporationFront;

    /** 法人身份证反面 */
    @Excel(name = "法人身份证反面")
    private String corporationBack;

    /** 法人姓名 */
    @Excel(name = "法人姓名")
    private String corporationName;

    /** 法人身份证号 */
    @Excel(name = "法人身份证号")
    private String corporationIdCard;

    /** 法人手机号 */
    @Excel(name = "法人手机号")
    private String corporationPhone;
    /**
     * 法人居住地址
     */
    private String corporationAddress;
    /**
     * 法人证件有效期
     */
    private String corporationExpirationDate;

    /** 家庭人口数 */
    @Excel(name = "家庭人口数")
    private String familyPopulation;

    /** 法人职业 */
    @Excel(name = "法人职业")
    private String corporationJob;

    /** 有无贷款 Y：是 N：否 */
    @Excel(name = "有无贷款 Y：是 N：否")
    private String isLoan;

    /** 应收应付款 */
    @Excel(name = "应收应付款")
    private String receivablePay;

    /** 经营情况 */
    @Excel(name = "经营情况")
    private String businessSituation;

    /** 经营效益 */
    @Excel(name = "经营效益")
    private String businessEfficiency;

    /** 法人婚姻状态 */
    @Excel(name = "法人婚姻状态")
    private String corporationMaritalStatus;

    /** 配偶身份证正面 */
    @Excel(name = "配偶身份证正面")
    private String spouseFront;

    /** 配偶身份证反面 */
    @Excel(name = "配偶身份证反面")
    private String spouseBack;

    /** 配偶姓名 */
    @Excel(name = "配偶姓名")
    private String spouseName;

    /** 配偶身份证号 */
    @Excel(name = "配偶身份证号")
    private String spouseIdCard;

    /** 配偶手机号 */
    @Excel(name = "配偶手机号")
    private String spousePhone;

    /** 担保类型 */
    @Excel(name = "担保类型")
    private String guaranteeType;

    /** 反担保人身份证正面 */
    @Excel(name = "反担保人身份证正面")
    private String guaranteeFront;

    /** 反担保人身份证反面 */
    @Excel(name = "反担保人身份证反面")
    private String guaranteeBack;

    /** 反担保人姓名 */
    @Excel(name = "反担保人姓名")
    private String guaranteeName;

    /** 反担保人身份证号 */
    @Excel(name = "反担保人身份证号")
    private String guaranteeIdCard;

    /** 反担保人手机号 */
    @Excel(name = "反担保人手机号")
    private String guaranteePhone;

    /** 反担保人婚姻状态 */
    @Excel(name = "反担保人婚姻状态")
    private String guaranteeMaritalStatus;

    /** 反担保人配偶身份证正面 */
    @Excel(name = "反担保人配偶身份证正面")
    private String guaranteeSpouseFront;

    /** 反担保人配偶身份证反面 */
    @Excel(name = "反担保人配偶身份证反面")
    private String guaranteeSpouseBack;

    /** 反担保人配偶姓名 */
    @Excel(name = "反担保人配偶姓名")
    private String guaranteeSpouseName;

    /** 反担保人配偶身份证号 */
    @Excel(name = "反担保人配偶身份证号")
    private String guaranteeSpouseIdCard;

    /** 反担保人配偶手机号 */
    @Excel(name = "反担保人配偶手机号")
    private String guaranteeSpousePhone;

    /** 申请人用户ID */
    @Excel(name = "申请人用户ID")
    private Long userId;

    /** 申请人身份证号码 */
    @Excel(name = "申请人身份证号码")
    private String idCard;

    /** 申请时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "申请时间", width = 30, dateFormat = "yyyy-MM-dd")
    private Date applicationTime;

    /** 归档时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "归档时间", width = 30, dateFormat = "yyyy-MM-dd")
    private Date fileTime;

    /** 贷款申请进度(业务进度表查询进度列表)：
     2：业务审核/分配 3：担保初审 4：尽职调查 5：初审风险合规 6：评审会 7：合同签约 8：放款合规风险审核 9：放款通知 10：归档 */
    @Excel(name = "贷款申请进度(业务进度表查询进度列表)：")
    private String loanSchedule;
    /** 贷款申请进度名称(中文字) */
    private String loanScheduleName;

    /** 审核进度1：业务审核/分配 2：A角色审核 3：B角色审核 4：风险审核 5：尽职调查 6：初审风险合规 7：上会评审 */
    @Excel(name = "审核进度1：业务审核/分配 2：A角色审核 3：B角色审核 4：风险审核 5：尽职调查 6：初审风险合规 7：上会评审")
    private String auditSchedule;

    /** 审核状态 1：待审核 2：已通过 3：未通过 4:申诉*/
    @Excel(name = "审核状态 1：待审核 2：已通过 3：未通过 4:申诉")
    private String auditType;

    /** 贷款申请状态 1：暂存 2：正常 3：回收站 4：归档 */
    @Excel(name = "贷款申请状态 1：暂存 2：正常 3：回收站 4：归档")
    private String loanApplicationType;

    /** A角色用户ID */
    @Excel(name = "A角色用户ID")
    private Long aUserId;

    /** A角色用户名称 */
    @Excel(name = "A角色用户名称")
    private String aUserName;

    /** B角色用户ID */
    @Excel(name = "B角色用户ID")
    private Long bUserId;

    /** B角色用户名称 */
    @Excel(name = "B角色用户名称")
    private String bUserName;

    private String type;
    /**
     * 全体股东信息附件
     */
    private List<ShareholderFj> shareholderFjList;
    /**
     *相关附件
     */
    private List<LoanApplicationFj> loanApplicationFjList;

    /*只在返回时使用*/
    /**
     * 基础附件
     */
    private Map<String,List<LoanApplicationFj>> basicFj;

    /**
     * 申报附件
     */
    private Map<String,List<LoanApplicationFj>> declareFj;
    /**
     * 文件出具
     */
    private Map<String,List<LoanApplicationFj>> fileFj;
    /**
     * 其他附件
     */
    private Map<String,List<LoanApplicationFj>> otherFj;


    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }

    public String getApplicationType() {
        return applicationType;
    }

    public void setApplicationType(String applicationType) {
        this.applicationType = applicationType;
    }

    public String getCorporationAddress() {
        return corporationAddress;
    }

    public void setCorporationAddress(String corporationAddress) {
        this.corporationAddress = corporationAddress;
    }

    public String getCorporationExpirationDate() {
        return corporationExpirationDate;
    }

    public void setCorporationExpirationDate(String corporationExpirationDate) {
        this.corporationExpirationDate = corporationExpirationDate;
    }

    public SysUserEnterprise getSysUserEnterprise() {
        return sysUserEnterprise;
    }

    public void setSysUserEnterprise(SysUserEnterprise sysUserEnterprise) {
        this.sysUserEnterprise = sysUserEnterprise;
    }

    public Long getEnterpriseId() {
        return enterpriseId;
    }

    public void setEnterpriseId(Long enterpriseId) {
        this.enterpriseId = enterpriseId;
    }


    public Map<String, List<LoanApplicationFj>> getBasicFj() {
        return basicFj;
    }

    public void setBasicFj(Map<String, List<LoanApplicationFj>> basicFj) {
        this.basicFj = basicFj;
    }

    public Map<String, List<LoanApplicationFj>> getDeclareFj() {
        return declareFj;
    }

    public void setDeclareFj(Map<String, List<LoanApplicationFj>> declareFj) {
        this.declareFj = declareFj;
    }

    public Map<String, List<LoanApplicationFj>> getFileFj() {
        return fileFj;
    }

    public void setFileFj(Map<String, List<LoanApplicationFj>> fileFj) {
        this.fileFj = fileFj;
    }

    public Map<String, List<LoanApplicationFj>> getOtherFj() {
        return otherFj;
    }

    public void setOtherFj(Map<String, List<LoanApplicationFj>> otherFj) {
        this.otherFj = otherFj;
    }

    public String getLoanScheduleName() {
        return loanScheduleName;
    }

    public void setLoanScheduleName(String loanScheduleName) {
        this.loanScheduleName = loanScheduleName;
    }

    public List<ShareholderFj> getShareholderFjList() {
        return shareholderFjList;
    }

    public void setShareholderFjList(List<ShareholderFj> shareholderFjList) {
        this.shareholderFjList = shareholderFjList;
    }

    public List<LoanApplicationFj> getLoanApplicationFjList() {
        return loanApplicationFjList;
    }

    public void setLoanApplicationFjList(List<LoanApplicationFj> loanApplicationFjList) {
        this.loanApplicationFjList = loanApplicationFjList;
    }

    public void setLoanApplicationId(Long loanApplicationId)
    {
        this.loanApplicationId = loanApplicationId;
    }

    public Long getLoanApplicationId() 
    {
        return loanApplicationId;
    }
    public void setLoanApplicationNumber(String loanApplicationNumber) 
    {
        this.loanApplicationNumber = loanApplicationNumber;
    }

    public String getLoanApplicationNumber() 
    {
        return loanApplicationNumber;
    }

    public Double getApplicationAmount() {
        return applicationAmount;
    }

    public void setApplicationAmount(Double applicationAmount) {
        this.applicationAmount = applicationAmount;
    }

    public void setApplicationBank(String applicationBank)
    {
        this.applicationBank = applicationBank;
    }

    public String getApplicationBank() 
    {
        return applicationBank;
    }
    public void setUsagePeriod(String usagePeriod) 
    {
        this.usagePeriod = usagePeriod;
    }

    public String getUsagePeriod() 
    {
        return usagePeriod;
    }
    public void setPurposeFunds(String purposeFunds) 
    {
        this.purposeFunds = purposeFunds;
    }

    public String getPurposeFunds() 
    {
        return purposeFunds;
    }
    public void setRepaymentSource(String repaymentSource) 
    {
        this.repaymentSource = repaymentSource;
    }

    public String getRepaymentSource() 
    {
        return repaymentSource;
    }
    public void setEnterpriseName(String enterpriseName) 
    {
        this.enterpriseName = enterpriseName;
    }

    public String getEnterpriseName() 
    {
        return enterpriseName;
    }
    public void setCategoryType(String categoryType) 
    {
        this.categoryType = categoryType;
    }

    public String getCategoryType() 
    {
        return categoryType;
    }
    public void setIsMake(String isMake) 
    {
        this.isMake = isMake;
    }

    public String getIsMake() 
    {
        return isMake;
    }
    public void setIsNew(String isNew) 
    {
        this.isNew = isNew;
    }

    public String getIsNew() 
    {
        return isNew;
    }
    public void setIsSmall(String isSmall) 
    {
        this.isSmall = isSmall;
    }

    public String getIsSmall() 
    {
        return isSmall;
    }
    public void setIsDuty(String isDuty) 
    {
        this.isDuty = isDuty;
    }

    public String getIsDuty() 
    {
        return isDuty;
    }
    public void setCompanyIntroduction(String companyIntroduction) 
    {
        this.companyIntroduction = companyIntroduction;
    }

    public String getCompanyIntroduction() 
    {
        return companyIntroduction;
    }
    public void setCustomerType(String customerType) 
    {
        this.customerType = customerType;
    }

    public String getCustomerType() 
    {
        return customerType;
    }
    public void setCorporationFront(String corporationFront) 
    {
        this.corporationFront = corporationFront;
    }

    public String getCorporationFront() 
    {
        return corporationFront;
    }
    public void setCorporationBack(String corporationBack) 
    {
        this.corporationBack = corporationBack;
    }

    public String getCorporationBack() 
    {
        return corporationBack;
    }
    public void setCorporationName(String corporationName) 
    {
        this.corporationName = corporationName;
    }

    public String getCorporationName() 
    {
        return corporationName;
    }
    public void setCorporationIdCard(String corporationIdCard) 
    {
        this.corporationIdCard = corporationIdCard;
    }

    public String getCorporationIdCard() 
    {
        return corporationIdCard;
    }
    public void setCorporationPhone(String corporationPhone) 
    {
        this.corporationPhone = corporationPhone;
    }

    public String getCorporationPhone() 
    {
        return corporationPhone;
    }
    public void setFamilyPopulation(String familyPopulation) 
    {
        this.familyPopulation = familyPopulation;
    }

    public String getFamilyPopulation() 
    {
        return familyPopulation;
    }
    public void setCorporationJob(String corporationJob) 
    {
        this.corporationJob = corporationJob;
    }

    public String getCorporationJob() 
    {
        return corporationJob;
    }
    public void setIsLoan(String isLoan) 
    {
        this.isLoan = isLoan;
    }

    public String getIsLoan() 
    {
        return isLoan;
    }
    public void setReceivablePay(String receivablePay) 
    {
        this.receivablePay = receivablePay;
    }

    public String getReceivablePay() 
    {
        return receivablePay;
    }
    public void setBusinessSituation(String businessSituation) 
    {
        this.businessSituation = businessSituation;
    }

    public String getBusinessSituation() 
    {
        return businessSituation;
    }
    public void setBusinessEfficiency(String businessEfficiency) 
    {
        this.businessEfficiency = businessEfficiency;
    }

    public String getBusinessEfficiency() 
    {
        return businessEfficiency;
    }
    public void setCorporationMaritalStatus(String corporationMaritalStatus) 
    {
        this.corporationMaritalStatus = corporationMaritalStatus;
    }

    public String getCorporationMaritalStatus() 
    {
        return corporationMaritalStatus;
    }
    public void setSpouseFront(String spouseFront) 
    {
        this.spouseFront = spouseFront;
    }

    public String getSpouseFront() 
    {
        return spouseFront;
    }
    public void setSpouseBack(String spouseBack) 
    {
        this.spouseBack = spouseBack;
    }

    public String getSpouseBack() 
    {
        return spouseBack;
    }
    public void setSpouseName(String spouseName) 
    {
        this.spouseName = spouseName;
    }

    public String getSpouseName() 
    {
        return spouseName;
    }
    public void setSpouseIdCard(String spouseIdCard) 
    {
        this.spouseIdCard = spouseIdCard;
    }

    public String getSpouseIdCard() 
    {
        return spouseIdCard;
    }
    public void setSpousePhone(String spousePhone) 
    {
        this.spousePhone = spousePhone;
    }

    public String getSpousePhone() 
    {
        return spousePhone;
    }
    public void setGuaranteeType(String guaranteeType) 
    {
        this.guaranteeType = guaranteeType;
    }

    public String getGuaranteeType() 
    {
        return guaranteeType;
    }
    public void setGuaranteeFront(String guaranteeFront) 
    {
        this.guaranteeFront = guaranteeFront;
    }

    public String getGuaranteeFront() 
    {
        return guaranteeFront;
    }
    public void setGuaranteeBack(String guaranteeBack) 
    {
        this.guaranteeBack = guaranteeBack;
    }

    public String getGuaranteeBack() 
    {
        return guaranteeBack;
    }
    public void setGuaranteeName(String guaranteeName) 
    {
        this.guaranteeName = guaranteeName;
    }

    public String getGuaranteeName() 
    {
        return guaranteeName;
    }
    public void setGuaranteeIdCard(String guaranteeIdCard) 
    {
        this.guaranteeIdCard = guaranteeIdCard;
    }

    public String getGuaranteeIdCard() 
    {
        return guaranteeIdCard;
    }
    public void setGuaranteePhone(String guaranteePhone) 
    {
        this.guaranteePhone = guaranteePhone;
    }

    public String getGuaranteePhone() 
    {
        return guaranteePhone;
    }
    public void setGuaranteeMaritalStatus(String guaranteeMaritalStatus) 
    {
        this.guaranteeMaritalStatus = guaranteeMaritalStatus;
    }

    public String getGuaranteeMaritalStatus() 
    {
        return guaranteeMaritalStatus;
    }
    public void setGuaranteeSpouseFront(String guaranteeSpouseFront) 
    {
        this.guaranteeSpouseFront = guaranteeSpouseFront;
    }

    public String getGuaranteeSpouseFront() 
    {
        return guaranteeSpouseFront;
    }
    public void setGuaranteeSpouseBack(String guaranteeSpouseBack) 
    {
        this.guaranteeSpouseBack = guaranteeSpouseBack;
    }

    public String getGuaranteeSpouseBack() 
    {
        return guaranteeSpouseBack;
    }
    public void setGuaranteeSpouseName(String guaranteeSpouseName) 
    {
        this.guaranteeSpouseName = guaranteeSpouseName;
    }

    public String getGuaranteeSpouseName() 
    {
        return guaranteeSpouseName;
    }
    public void setGuaranteeSpouseIdCard(String guaranteeSpouseIdCard) 
    {
        this.guaranteeSpouseIdCard = guaranteeSpouseIdCard;
    }

    public String getGuaranteeSpouseIdCard() 
    {
        return guaranteeSpouseIdCard;
    }
    public void setGuaranteeSpousePhone(String guaranteeSpousePhone) 
    {
        this.guaranteeSpousePhone = guaranteeSpousePhone;
    }

    public String getGuaranteeSpousePhone() 
    {
        return guaranteeSpousePhone;
    }
    public void setUserId(Long userId) 
    {
        this.userId = userId;
    }

    public Long getUserId() 
    {
        return userId;
    }
    public void setIdCard(String idCard) 
    {
        this.idCard = idCard;
    }

    public String getIdCard() 
    {
        return idCard;
    }
    public void setApplicationTime(Date applicationTime) 
    {
        this.applicationTime = applicationTime;
    }

    public Date getApplicationTime() 
    {
        return applicationTime;
    }
    public void setFileTime(Date fileTime) 
    {
        this.fileTime = fileTime;
    }

    public Date getFileTime() 
    {
        return fileTime;
    }
    public void setLoanSchedule(String loanSchedule) 
    {
        this.loanSchedule = loanSchedule;
    }

    public String getLoanSchedule() 
    {
        return loanSchedule;
    }
    public void setAuditSchedule(String auditSchedule) 
    {
        this.auditSchedule = auditSchedule;
    }

    public String getAuditSchedule() 
    {
        return auditSchedule;
    }
    public void setAuditType(String auditType) 
    {
        this.auditType = auditType;
    }

    public String getAuditType() 
    {
        return auditType;
    }
    public void setLoanApplicationType(String loanApplicationType) 
    {
        this.loanApplicationType = loanApplicationType;
    }

    public String getLoanApplicationType() 
    {
        return loanApplicationType;
    }
    public void setaUserId(Long aUserId) 
    {
        this.aUserId = aUserId;
    }

    public Long getaUserId() 
    {
        return aUserId;
    }

    public String getaUserName() {
        return aUserName;
    }

    public void setaUserName(String aUserName) {
        this.aUserName = aUserName;
    }

    public Long getbUserId() {
        return bUserId;
    }

    public void setbUserId(Long bUserId) {
        this.bUserId = bUserId;
    }

    public String getbUserName() {
        return bUserName;
    }

    public void setbUserName(String bUserName) {
        this.bUserName = bUserName;
    }
}
