package com.ruoyi.system.service.loan;

import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.system.domain.loan.ShareholderFj;

import java.util.List;


/**
 * 全体股东附件Service接口
 * 
 * @author boman
 * @date 2024-04-24
 */
public interface IShareholderFjService 
{
    /**
     * 查询全体股东附件
     * 
     * @param shareholderFjId 全体股东附件主键
     * @return 全体股东附件
     */
    public ShareholderFj selectShareholderFjByShareholderFjId(Long shareholderFjId);

    /**
     * 查询全体股东附件列表
     * 
     * @param shareholderFj 全体股东附件
     * @return 全体股东附件集合
     */
    public List<ShareholderFj> selectShareholderFjList(ShareholderFj shareholderFj);

    /**
     * 新增全体股东附件
     * 
     * @param shareholderFj 全体股东附件
     * @return 结果
     */
    public int insertShareholderFj(ShareholderFj shareholderFj);

    /**
     * 修改全体股东附件
     * 
     * @param shareholderFj 全体股东附件
     * @return 结果
     */
    public int updateShareholderFj(ShareholderFj shareholderFj);

    /**
     * 批量删除全体股东附件
     * 
     * @param shareholderFjIds 需要删除的全体股东附件主键集合
     * @return 结果
     */
    public int deleteShareholderFjByShareholderFjIds(Long[] shareholderFjIds);

    /**
     * 删除全体股东附件信息
     * 
     * @param shareholderFjId 全体股东附件主键
     * @return 结果
     */
    public int deleteShareholderFjByShareholderFjId(Long shareholderFjId);

}
